unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  Db, DBTables, StdCtrls, DBGrids, Grids,
  ARWordReport, Buttons, Mask;

type
  TForm1 = class(TForm)
    WordReport1: TARWordReport;
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Query1: TQuery;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    eFile: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure WordReport1NeedSQL(Sender: TObject; SQLstring: String;
      var ResultDataset: TDataSet);
    procedure WordReport2Tag(Sender: TObject; var TagValue: String);
  private
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

//uses VerInfo;
uses Clipbrd, ARWordReportPerfom;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  //Table1.DatabaseName:= ExtractFileDir(Application.ExeName);
  Query1.DatabaseName:= Table1.DatabaseName;
  Table1.Open;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  dsi: TWRDSItem;
begin
  Screen.Cursor:= crHourGlass;
  try
    WordReport1.Filename:= eFile.Text; //Template
    dsi:= TWRDSItem(WordReport1.DataSetList.Add);
    dsi.Dataset:= Table1;
    dsi.DSName:='RTData';
    // It is enough to use only Preview method
    // in most cases when you work with TARWordReport.
    try
      WordReport1.Preview;
    finally
      WordReport1.CloseWord; //it will close Word if it is invisible and will free unneeded resources
    end;
    Query1.Close;
    Query1.SQL.Clear;
  finally
    Screen.Cursor:= crDefault;
  end;
end;

procedure TForm1.WordReport1NeedSQL(Sender: TObject; SQLstring: String;
  var ResultDataset: TDataSet);
begin
  // Initialy ResultDataset=nil
  // You need to point it to your dataset
  try
    //Check SQLstring here if needed
    //(like a ARWordReportPerfom.CheckQuery function)
    Query1.Close;
    Query1.SQL.Clear;
    Query1.SQL.Add(SQLstring);
    Query1.Open;
    ResultDataset:= Query1;
  except
    ResultDataset:= nil;
  end;
end;

procedure TForm1.WordReport2Tag(Sender: TObject; var TagValue: String);
var
  i: integer;
  s, s1: string;
begin
  // Using OnTag Event
  TagValue:= AnsiUpperCase(TagValue);
  if TagValue='NOWDATE' then TagValue:= DateToStr(now)
  else if TagValue='NOWTIME' then TagValue:= TimeToStr(now)
  else if TagValue='CLIPBOARD' then begin
    WordReport1.W.Selection.Paste; //Using MS Word OLE interface
    TagValue:='';
  end else if AnsiPos('INC_TEMPLATE("',TagValue)=1 then begin
    //Insert external report
    s:= GetTextBetween(TagValue,'INC_TEMPLATE("','")');
    i:= AnsiPos(':',s);
    if i>0 then begin
      s1:= Copy(s,i+1,maxint);//file name
      s:= Copy(s,1, i-1);//parameters
    end;
    InsertReport((Sender as TARWordReport), s, s1);
    TagValue:='';
  end else
    TagValue:='';
end;

end.
